	.dbfile C:\iccv7arm\examples.arm\hellofoo\myserial.c
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
	.dbfile C:\iccv7arm\examples.arm\hellofoo\myserial.c
	EXPORT _setbaud
	.dbfunc e setbaud _setbaud fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
;        baudDiv -> R6
;           baud -> R6
_setbaud:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 9
; // serial.c and io.c modified for LPC2106 at 8 MHz
; #include <ARM/philips/lpc210x.h>
; #include <stdio.h>
; 
; /* This assumes a 14.7456 MHz clock. If not, you'll need to change the
;  * baud rate calculation.
;  */
; void setbaud(int baud)
; {
	.dbline 12
; 	// Default VPB clock is 1/4 processor clock, or 3686400 Hz.
; 	// Baud divisor is VPB/16*baud, or 230400/baud
;     int baudDiv = 230400/baud;
	mov R1,R6
	mov R0,#230400
	bl div32s
	mov R6,R0
	.dbline 14
; 
;     UART0_LCR = 0x00000083;	 	    // Enable the divisor
	mov R4,#131
	ldr R5,LIT_setbaud+0
	str R4,[R5,#0]
	.dbline 16
; 	
;     UART0_DLM = baudDiv >> 8;	    // Divisor latch MSB 
	mov R4,R6,asr #8
	ldr R5,LIT_setbaud+4
	str R4,[R5,#0]
	.dbline 17
;     UART0_DLL = baudDiv & 0xFF;     // Divisor latch LSB 
	and R4,R6,#255
	ldr R5,LIT_setbaud+8
	str R4,[R5,#0]
	.dbline 18
;     UART0_LCR = 0x00000003;  	    // 8 bits, no parity, 1 stop bit
	mov R4,#3
	ldr R5,LIT_setbaud+0
	str R4,[R5,#0]
	.dbline -2
L1:
	ldmfd R11,{R4,R5,R6,R11,SP,PC}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\examples.arm\hellofoo\myserial.c
LIT_setbaud:
	DCD -536821748
	DCD -536821756
	DCD -536821760
	.dbsym r baudDiv 6 I
	.dbsym r baud 6 I
	.dbend
	EXPORT _getchar
	.dbfunc e getchar _getchar fI
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
_getchar:
	.dbline -1
	.dbline 22
; }
; 
; int getchar(void)
; {
L3:
	.dbline 24
;     while (!(UART0_LSR & 0x01))
; 	{
	.dbline 25
; 	}
L4:
	.dbline 23
	ldr R1,LIT_getchar+0
	ldr R1,[R1,#0]
	tst R1,#1
	beq L3
	.dbline 27
; 
; 	return UART0_RBR;
	ldr R1,LIT_getchar+4
	ldr R1,[R1,#0]
	mov R0,R1
	.dbline -2
L2:
	mov R15,R14
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\examples.arm\hellofoo\myserial.c
LIT_getchar:
	DCD -536821740
	DCD -536821760
	.dbend
	EXPORT _putchar
	.dbfunc e putchar _putchar fI
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
;              c -> R6
_putchar:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 31
; }
; 
; int putchar(char c)
; {
	.dbline 32
; 	if (c == '\n')
	and R4,R6,#255
	cmp R4,#10
	bne L10
	.dbline 33
; 		putchar('\r');
	mov R0,#13
	bl _putchar
L9:
	.dbline 36
; 
;     while (!(UART0_LSR & 0x20))
; 	{
	.dbline 37
; 	} 
L10:
	.dbline 35
	ldr R4,LIT_putchar+0
	ldr R4,[R4,#0]
	tst R4,#32
	beq L9
	.dbline 39
;   
;     UART0_THR = c;
	and R4,R6,#255
	ldr R5,LIT_putchar+4
	str R4,[R5,#0]
	.dbline 40
; 	return c;
	and R0,R6,#255
	.dbline -2
L6:
	ldmfd R11,{R4,R5,R6,R11,SP,PC}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\examples.arm\hellofoo\myserial.c
LIT_putchar:
	DCD -536821740
	DCD -536821760
	.dbsym r c 6 c
	.dbend
	END
